# Kanidm

- [Introduction to Kanidm](intro.md)
- [Installing the Server](installing_the_server.md)
  - [Choosing a Domain Name](choosing_a_domain_name.md)
  - [Preparing for your Deployment](prepare_the_server.md)
  - [Server Configuration and Install](server_configuration.md)
  - [Platform Security Hardening](security_hardening.md)
  - [Server Updates](server_update.md)
- [Client Tools](client_tools.md)
  - [Installing client tools](installing_client_tools.md)

# Administration

- [Administration](administrivia.md)
  - [Accounts and Groups](accounts_and_groups.md)
  - [Authentication and Credentials](authentication.md)
  - [POSIX Accounts and Groups](posix_accounts.md)
  - [Backup and Restore](backup_restore.md)
  - [Database Maintenance](database_maint.md)
  - [Domain Rename](domain_rename.md)
  - [Monitoring the platform](monitoring.md)
  - [Password Quality and Badlisting](password_quality.md)
  - [The Recycle Bin](recycle_bin.md)

# Services

- [PAM and nsswitch](integrations/pam_and_nsswitch.md)
- [SSH Key Distribution](ssh_key_dist.md)
- [Oauth2](integrations/oauth2.md)
- [LDAP](integrations/ldap.md)
- [RADIUS](integrations/radius.md)

# Synchronisation

- [Concepts](sync/concepts.md)
- [FreeIPA](sync/freeipa.md)

# Integration Examples

- [Kubernetes Ingress](examples/k8s_ingress_example.md)
- [Traefik](integrations/traefik.md)

# Support

- [Troubleshooting](troubleshooting.md)
- [Frequently Asked Questions](frequently_asked_questions.md)
- [Glossary of Technical Terms](glossary.md)

# For Developers

- [Developer Guide](DEVELOPER_README.md)
- [FAQ](developers/faq.md)
- [Design Documents]()
  - [Access Profiles 2022](developers/designs/access_profiles_rework_2022.md)
  - [Access Profiles Original](developers/designs/access_profiles_and_security.md)
  - [REST Interface](developers/designs/rest_interface.md)
  - [Elevated Priv Mode](developers/designs/elevated_priv_mode.md)
  - [Oauth2 Refresh Tokens](developers/designs/oauth2_refresh_tokens.md)
- [Python Module](developers/python.md)
- [RADIUS Integration](developers/radius.md)

## Packaging

- [Packaging](packaging.md)
  - [Debian/Ubuntu](packaging_debs.md)
